// boardbox.as

Boardbox = function () {
	this.propActive = true;
	this.propAlive = true;
	this.propPointval = 0;
	this.propIsDare = false;
	this.propBgCol = new Color (this.i_bg);
	this.propOlCol = new Color (this.i_ol);
	this.propBgColors = [];
	this.propOlColors = [];
	this.setBgColors ([0xFFFFFF,0xFFFFFF,0xFFFFFF]);
	this.setOlColors ([0x000000,0x000000,0x000000]);
	this.propOnRelease = function () {}
}

Boardbox.prototype = new MovieClip ();

// --------------------- METHODS --------------------

Boardbox.prototype.getPointval = function () {
	return this.propPointval;
	ASSetPropFlags (Boardbox.prototype, ['getPointval'], 1);
}

Boardbox.prototype.setPointval = function (p) {
	this.propPointval = p;
	this.gotoAndStop (p/100);
	ASSetPropFlags (Boardbox.prototype, ['setPointval'], 1);
}

Boardbox.prototype.getIsDare = function () {
	return this.propIsDare;
	ASSetPropFlags (Boardbox.prototype, ['getIsDare'], 1);
}

Boardbox.prototype.setIsDare = function (p) {
	this.propIsDare = p;
	ASSetPropFlags (Boardbox.prototype, ['setIsDare'], 1);
}

Boardbox.prototype.getAlive = function () {
	return this.propAlive;
	ASSetPropFlags (Boardbox.prototype, ['getAlive'], 1);
}

Boardbox.prototype.setAlive = function (p) {
	ASSetPropFlags (Boardbox.prototype, ['setAlive'], 1);
}

Boardbox.prototype.getBgColors = function () {
	return this.propBgColors;
	ASSetPropFlags (Boardbox.prototype, ['getBgColors'], 1);
}

Boardbox.prototype.setBgColors = function (p) {
	this.propBgColors = p;
	this.propBgCol.setRGB (this.propBgColors[0]);
	ASSetPropFlags (Boardbox.prototype, ['setBgColors'], 1);
}

Boardbox.prototype.getOlColors = function () {
	return this.propOlColors;
	ASSetPropFlags (Boardbox.prototype, ['getOlColors'], 1);
}

Boardbox.prototype.setOlColors = function (p) {
	this.propOlColors = p;
	this.propOlCol.setRGB (this.propOlColors[0]);
	ASSetPropFlags (Boardbox.prototype, ['setOlColors'], 1);
}

Boardbox.prototype.onRollOver = function () {
	if (this.propActive && this.propAlive) {
		this.propBgCol.setRGB (this.propBgColors[1]);
		this.propOlCol.setRGB (this.propOlColors[1]);
	}
	ASSetPropFlags (Boardbox.prototype, ['onRollOver'], 1);
}

Boardbox.prototype.onRollOut = function () {
	if (this.propActive && this.propAlive) {
		this.propBgCol.setRGB (this.propBgColors[0]);
		this.propOlCol.setRGB (this.propOlColors[0]);
	}
	ASSetPropFlags (Boardbox.prototype, ['onRollOut'], 1);
}

Boardbox.prototype.onReleaseOutside = function () {
	if (this.propActive && this.propAlive) {
		this.onRollOut ();
	}
	ASSetPropFlags (Boardbox.prototype, ['onReleaseOutside'], 1);
}

Boardbox.prototype.onRelease = function () {
	if (this.propActive && this.propAlive) {
		this.propOnRelease (this);
	}
	ASSetPropFlags (Boardbox.prototype, ['onRelease'], 1);
}

Boardbox.prototype.deactivate = function () {
	if (this.propAlive) {
		this.propActive = false;
		this.useHandCursor = false;
	}
	ASSetPropFlags (Boardbox.prototype, ['deactivate'], 1);
}

Boardbox.prototype.activate = function () {
	if (this.propAlive) {
		this.propActive = true;
		this.useHandCursor = true;
	}
	ASSetPropFlags (Boardbox.prototype, ['activate'], 1);
}

Boardbox.prototype.kill = function () {
	this.gotoAndStop (4);
	this.propBgCol.setRGB (this.propBgColors[2]);
	this.propOlCol.setRGB (this.propOlColors[2]);
	this.useHandCursor = false;
	this.propAlive = false;
	ASSetPropFlags (Boardbox.prototype, ['kill'], 1);
}


//  ---------------- PROPERTIES -----------------

Boardbox.prototype.addProperty ('alive', Boardbox.prototype.getAlive, Boardbox.prototype.setAlive);
Boardbox.prototype.addProperty ('pointval', Boardbox.prototype.getPointval, Boardbox.prototype.setPointval);
Boardbox.prototype.addProperty ('isDare', Boardbox.prototype.getIsDare, Boardbox.prototype.setIsDare);
Boardbox.prototype.addProperty ('bgColors', Boardbox.prototype.getBgColors, Boardbox.prototype.setBgColors);
Boardbox.prototype.addProperty ('olColors', Boardbox.prototype.getOlColors, Boardbox.prototype.setOlColors);


Object.registerClass ('m_bdbox', Boardbox);
